<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Automate cellulaire:  Fichier source de src/utils.c</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Automate cellulaire
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Généré par Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Recherche');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Recherche');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">utils.c</div>  </div>
</div><!--header-->
<div class="contents">
<a href="utils_8c.html">Aller à la documentation de ce fichier.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;utils.h&quot;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">//                       Autres Fonctions                     //</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00027"></a><span class="lineno"><a class="line" href="utils_8c.html#a24de25c90e051b42fa3d59a7814b0b7c">   27</a></span>&#160;<span class="comment"></span><span class="keywordtype">char</span>* <a class="code" href="utils_8c.html#a24de25c90e051b42fa3d59a7814b0b7c">decimal_to_binary</a>(<span class="keywordtype">char</span>** ptr_char, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> val){</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;  <span class="keywordtype">char</span>* binary = *ptr_char;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160; </div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; 8; i++) {</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keywordflow">if</span> ((<span class="keywordtype">int</span>)(val / pow(2, 7 - i)) == 1) {</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;      binary[i] = <span class="charliteral">&#39;1&#39;</span>;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;      val = val - pow(2, 7 - i);</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    }</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordflow">else</span>{</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;      binary[i] = <span class="charliteral">&#39;0&#39;</span>;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    }</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;  }</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;  <span class="keywordflow">return</span> binary;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;}</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160; </div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div>
<div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="utils_8c.html#a3b7908e8916a52b84521dfee1c9fa0d3">   49</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="utils_8c.html#a3b7908e8916a52b84521dfee1c9fa0d3">binary_to_decimal</a>(<span class="keywordtype">char</span>* binary){</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;  <span class="keywordtype">int</span> decimal = 0;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> taille_val = strlen(binary);</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; taille_val; i++) {</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    decimal += (binary[i] - <span class="charliteral">&#39;0&#39;</span>) * pow(2,  taille_val - 1 - i);</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;  }</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;  <span class="keywordflow">return</span> decimal;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;}</div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="autils_8c_html_a3b7908e8916a52b84521dfee1c9fa0d3"><div class="ttname"><a href="utils_8c.html#a3b7908e8916a52b84521dfee1c9fa0d3">binary_to_decimal</a></div><div class="ttdeci">int binary_to_decimal(char *binary)</div><div class="ttdoc">Convertit un nombre binaire en decimal.</div><div class="ttdef"><b>Definition:</b> <a href="utils_8c_source.html#l00049">utils.c:49</a></div></div>
<div class="ttc" id="autils_8c_html_a24de25c90e051b42fa3d59a7814b0b7c"><div class="ttname"><a href="utils_8c.html#a24de25c90e051b42fa3d59a7814b0b7c">decimal_to_binary</a></div><div class="ttdeci">char * decimal_to_binary(char **ptr_char, unsigned int val)</div><div class="ttdoc">Convertir un nombre decimal entre 0 et 256 en binaire.</div><div class="ttdef"><b>Definition:</b> <a href="utils_8c_source.html#l00027">utils.c:27</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Généré par &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
